Attribute VB_Name = "kWTHConvertCSS"
Option Explicit

Public Sub ConvertCSSExec(ByVal csspath As String)
    'AEgC[hƎ擾łȂX^C悤Ȃ̂ŋIɕʃ[h֕ύX
    If ActiveWindow.View.SplitSpecial = wdPaneNone Then
        ActiveWindow.ActivePane.View.Type = wdNormalView
    Else
        ActiveWindow.View.Type = wdNormalView
    End If
    
    Dim filenum As String
    filenum = FreeFile
    Open csspath For Output As filenum
    Print #filenum, "@charset ""Shift_JIS"";" & vbCrLf
    
    'body
    Dim rb As New kWTHCSSRuleSet
    Set rb = CreateBodyRuleSet()
    Print #filenum, rb.CreateCode
    Set rb = Nothing
    
    Dim s As Style
    For Each s In ActiveDocument.Styles
        If StyleTypeConvert(s.NameLocal) <> "" Then
            Dim r As kWTHCSSRuleSet
            Set r = CreateRuleSet(s)
            Print #filenum, r.CreateCode
            Set r = Nothing
        End If
    Next
    
    Close filenum
End Sub

Private Function CreateBodyRuleSet() As kWTHCSSRuleSet
    Dim r As New kWTHCSSRuleSet
    r.SetSelector "body"

    If ActiveDocument.Background.Fill.Visible = msoTrue Then
        r.AddProperty CreateProperty3("background-color", ConvertCSSColorHex(ActiveDocument.Background.Fill.ForeColor.RGB), False)
    End If
    
    r.AddProperty CreateProperty1("margin-top", ActiveDocument.PageSetup.TopMargin, "pt")
    r.AddProperty CreateProperty1("margin-bottom", ActiveDocument.PageSetup.BottomMargin, "pt")
    r.AddProperty CreateProperty1("margin-right", ActiveDocument.PageSetup.RightMargin, "pt")
    r.AddProperty CreateProperty1("margin-left", ActiveDocument.PageSetup.LeftMargin, "pt")
    
    Set CreateBodyRuleSet = r
End Function

Private Function CreateRuleSet(ByVal s As Style) As kWTHCSSRuleSet
    Dim r As New kWTHCSSRuleSet
    r.SetSelector StyleTypeConvert(s.NameLocal)
        
    '8 Box model
    If s.Type <> wdStyleTypeCharacter Then
        r.AddProperty CreateProperty1("margin-top", GetPageLineHeight * s.ParagraphFormat.LineUnitBefore, "pt")
        r.AddProperty CreateProperty1("margin-bottom", GetPageLineHeight * s.ParagraphFormat.LineUnitAfter, "pt")
        r.AddProperty CreateProperty1("margin-right", GetPageLineHeight * s.ParagraphFormat.CharacterUnitRightIndent, "pt")
        r.AddProperty CreateProperty1("margin-left", GetPageLineHeight * s.ParagraphFormat.CharacterUnitLeftIndent, "pt")
        '   padding-top ۂ̂
        With s.ParagraphFormat.Borders(wdBorderTop)
            r.AddProperty CreateProperty1("border-top-width", BorderWidthConvert(.LineWidth), "pt")
            r.AddProperty CreateProperty3("border-top-color", ConvertCSSColorHex(.color), False)
            r.AddProperty CreateProperty3("border-top-style", BorderStyleConvert(.LineStyle), False)
        End With
        With s.ParagraphFormat.Borders(wdBorderBottom)
            r.AddProperty CreateProperty1("border-bottom-width", BorderWidthConvert(.LineWidth), "pt")
            r.AddProperty CreateProperty3("border-bottom-color", ConvertCSSColorHex(.color), False)
            r.AddProperty CreateProperty3("border-bottom-style", BorderStyleConvert(.LineStyle), False)
        End With
        With s.ParagraphFormat.Borders(wdBorderRight)
            r.AddProperty CreateProperty1("border-right-width", BorderWidthConvert(.LineWidth), "pt")
            r.AddProperty CreateProperty3("border-right-color", ConvertCSSColorHex(.color), False)
            r.AddProperty CreateProperty3("border-right-style", BorderStyleConvert(.LineStyle), False)
        End With
        With s.ParagraphFormat.Borders(wdBorderLeft)
            r.AddProperty CreateProperty1("border-left-width", BorderWidthConvert(.LineWidth), "pt")
            r.AddProperty CreateProperty3("border-left-color", ConvertCSSColorHex(.color), False)
            r.AddProperty CreateProperty3("border-left-style", BorderStyleConvert(.LineStyle), False)
        End With
    End If
    
    '9 Visual formatting model
    If s.Type <> wdStyleTypeCharacter Then
        If s.ParagraphFormat.LineSpacingRule = wdLineSpace1pt5 _
                Or s.ParagraphFormat.LineSpacingRule = wdLineSpaceSingle _
                Or s.ParagraphFormat.LineSpacingRule = wdLineSpaceDouble Then
            r.AddProperty CreateProperty1("line-height", SpacingRuleConvert(s.ParagraphFormat.LineSpacingRule, s.Font.size), "pt")
        Else
            r.AddProperty CreateProperty1("line-height", s.ParagraphFormat.LineSpacing, "pt")
        End If
    End If
    
    '14 Colors and Backgrounds
    r.AddProperty CreateProperty3("color", ConvertCSSColorHex(s.Font.color), False)
    If s.Type <> wdStyleTypeCharacter Then
        If s.ParagraphFormat.Shading.BackgroundPatternColor <> wdColorAutomatic Then
            r.AddProperty CreateProperty3("background-color", ConvertCSSColorHex(s.ParagraphFormat.Shading.BackgroundPatternColor), False)
        End If
    End If

    '15 Fonts
    r.AddProperty CreateProperty3("font-family", s.Font.NameFarEast, True)
    r.AddProperty CreateProperty2("font-style", s.Font.Italic, "normal", "italic")
    r.AddProperty CreateProperty2("font-variant", s.Font.SmallCaps, "normal", "small-caps")
    r.AddProperty CreateProperty2("font-weight", s.Font.Bold, "normal", "bold")
    r.AddProperty CreateProperty1("font-size", s.Font.size, "pt")
    
    '16 Text
    If s.Type <> wdStyleTypeCharacter Then
        r.AddProperty CreateProperty1("text-indent", s.ParagraphFormat.CharacterUnitFirstLineIndent, "em")
        r.AddProperty CreateProperty3("text-align", AlignConvert(s.ParagraphFormat.Alignment), False)
    End If
    r.AddProperty CreateProperty3("text-decoration", CreateTextDecorationString(s.Font), False)
    r.AddProperty CreateProperty1("letter-spacing", s.Font.Spacing, "pt")
    '   word-spacing    Ȃ
    '   text-transform  Ȃ
    '   white-space     Ȃc?

    Set CreateRuleSet = r
End Function

Private Function CreateProperty1(ByVal propertyname As String, ByVal length As String, ByVal unit As String) As kWTHCSSProperty
    Dim p As New kWTHCSSProperty
    p.SetPropertyName propertyname
    p.AddValue CStr(length) & CStr(unit)
    Set CreateProperty1 = p
End Function

Private Function CreateProperty2(ByVal propertyname As String, ByVal val As Boolean, ByVal falsevalue As String, ByVal truevalue As String) As kWTHCSSProperty
    Dim p As New kWTHCSSProperty
    p.SetPropertyName propertyname
    If val Then
        p.AddValue truevalue
    Else
        p.AddValue falsevalue
    End If

    Set CreateProperty2 = p
End Function

Private Function CreateProperty3(ByVal propertyname As String, ByVal val As String, ByVal isquotes As Boolean) As kWTHCSSProperty
    Dim p As New kWTHCSSProperty
    p.SetPropertyName propertyname
    If isquotes Then
        p.AddValue "'" & val & "'"
    Else
        p.AddValue val
    End If

    Set CreateProperty3 = p
End Function

Private Function ConvertCSSColorHex(ByVal color As Long) As String
    Dim tmpstr As String
    Dim r As String
    Dim g As String
    Dim b As String
    tmpstr = Right("000000" & Hex(color), 6)
    r = Mid(tmpstr, 5, 2)
    g = Mid(tmpstr, 3, 2)
    b = Mid(tmpstr, 1, 2)
    ConvertCSSColorHex = "#" & r & g & b
End Function

Private Function StyleTypeConvert(ByVal stylename As String) As String
    Dim tmpstr As String
    Select Case stylename
        Case ActiveDocument.Styles(wdStyleHeading1):          tmpstr = "h1"
        Case ActiveDocument.Styles(wdStyleHeading2):          tmpstr = "h2"
        Case ActiveDocument.Styles(wdStyleHeading3):          tmpstr = "h3"
        Case ActiveDocument.Styles(wdStyleHeading4):          tmpstr = "h4"
        Case ActiveDocument.Styles(wdStyleHeading5):          tmpstr = "h5"
        Case ActiveDocument.Styles(wdStyleHeading6):          tmpstr = "h6"
        Case ActiveDocument.Styles(wdStyleNormal):            tmpstr = "p"
        '---Case ActiveDocument.Styles(wdStyleHtmlNormal):        tmpstr = "p"  '
        Case ActiveDocument.Styles(wdStyleBlockQuotation):    tmpstr = "blockquote p" 'ăzg?
        Case ActiveDocument.Styles(wdStyleListBullet):        tmpstr = "ul"
        Case ActiveDocument.Styles(wdStyleHtmlAcronym):       tmpstr = "abbr"       'lIabbr
        Case ActiveDocument.Styles(wdStyleHtmlAddress):       tmpstr = "address"    'ĈႤӖȃR
        Case ActiveDocument.Styles(wdStyleHtmlCite):          tmpstr = "cite"       'MSDN̐"s撬"ƂȂĂ񂾂Â?
        Case ActiveDocument.Styles(wdStyleHtmlCode):          tmpstr = "code"
        Case ActiveDocument.Styles(wdStyleHtmlDfn):           tmpstr = "dfn"
        Case ActiveDocument.Styles(wdStyleHtmlKbd):           tmpstr = "kbd"
        Case ActiveDocument.Styles(wdStyleHtmlPre):           tmpstr = "pre"
        Case ActiveDocument.Styles(wdStyleHtmlSamp):          tmpstr = "samp"
        Case ActiveDocument.Styles(wdStyleHtmlVar):           tmpstr = "var"
        Case ActiveDocument.Styles(wdStyleHyperlink):         tmpstr = "a"
        Case ActiveDocument.Styles(wdStyleHyperlinkFollowed): tmpstr = "a:visited"
        Case ActiveDocument.Styles(wdStyleEmphasis):          tmpstr = "em"
        Case ActiveDocument.Styles(wdStyleStrong):            tmpstr = "strong"
        Case Else:                                            tmpstr = ""
    End Select
    StyleTypeConvert = tmpstr
End Function

Private Function SpacingRuleConvert(ByVal wdlspacing As WdLineSpacing, ByVal fontsize As Double) As String
    Dim tmpstr As String
    Select Case wdlspacing
        Case wdLineSpaceSingle: tmpstr = GetLineHeight(fontsize)
        Case wdLineSpace1pt5:   tmpstr = GetLineHeight(fontsize) * 1.5
        Case wdLineSpaceDouble: tmpstr = GetLineHeight(fontsize) * 2
        Case Else:              tmpstr = 0
    End Select
    SpacingRuleConvert = tmpstr
End Function

Private Function BorderWidthConvert(ByVal wdbwidth As WdLineWidth) As String
    Dim tmpstr As String
    Select Case wdbwidth
        Case wdLineWidth025pt: tmpstr = 0.25
        Case wdLineWidth050pt: tmpstr = 0.5
        Case wdLineWidth075pt: tmpstr = 0.75
        Case wdLineWidth100pt: tmpstr = 1
        Case wdLineWidth150pt: tmpstr = 1.5
        Case wdLineWidth225pt: tmpstr = 2.25
        Case wdLineWidth300pt: tmpstr = 3
        Case wdLineWidth450pt: tmpstr = 4.5
        Case wdLineWidth600pt: tmpstr = 6
        Case Else:             tmpstr = 0
    End Select
    BorderWidthConvert = tmpstr
End Function

Private Function BorderStyleConvert(ByVal wdlstyle As WdLineStyle) As String
'wdLineStyleDashDot
'wdLineStyleDashDotDot
'wdLineStyleDashDotStroked
'wdLineStyleDashLargeGap
'wdLineStyleDashSmallGap
'wdLineStyleDoubleWavy
'wdLineStyleEmboss3D
'wdLineStyleEngrave3D
'wdLineStyleSingleWavy
'wdLineStyleThickThinLargeGap
'wdLineStyleThickThinMedGap
'wdLineStyleThinThickSmallGap
'wdLineStyleThinThickThinLargeGap
'wdLineStyleThinThickThinMedGap
'wdLineStyleThinThickThinSmallGap
'wdLineStyleTriple
'߂ǂ̂ŏLׂ͂solidɂ
    Dim tmpstr As String
    Select Case wdlstyle
        Case wdLineStyleDouble: tmpstr = "double"
        Case wdLineStyleDot:    tmpstr = "dotted"
        Case wdLineStyleSingle: tmpstr = "solid"
        Case wdLineStyleInset:  tmpstr = "inset"
        Case wdLineStyleOutset: tmpstr = "outset"
        Case wdLineStyleNone:   tmpstr = "none"
        Case Else:              tmpstr = "solid"
    End Select
    BorderStyleConvert = tmpstr
End Function

Private Function AlignConvert(ByVal wdalign As WdParagraphAlignment) As String
    Dim tmpstr As String
    Select Case wdalign
        Case wdAlignParagraphCenter: tmpstr = "center"
        Case wdAlignParagraphLeft:   tmpstr = "left"
        Case wdAlignParagraphRight:  tmpstr = "right"
        Case Else:                   tmpstr = "justify"
    End Select
    AlignConvert = tmpstr
End Function

Private Function CreateTextDecorationString(ByVal f As Font) As String
    Dim tmpstr As String
    
    If f.Underline <> wdUnderlineNone Then
        tmpstr = tmpstr & "underline "
    End If
    If f.StrikeThrough Or f.DoubleStrikeThrough Then
        tmpstr = tmpstr & "line-through "
    End If
    If f.Animation <> wdAnimationNone Then
        tmpstr = tmpstr & "blink "
    End If
    tmpstr = Trim(tmpstr)
    
    If tmpstr = "" Then
        tmpstr = "none"
    End If
    
    CreateTextDecorationString = tmpstr
End Function

Private Function GetPageLineHeight() As Double
    Dim tmpval As Double
    With ActiveDocument.PageSetup
        tmpval = PointsToMillimeters(.PageHeight) - PointsToMillimeters(.TopMargin) - PointsToMillimeters(.BottomMargin)
        tmpval = tmpval / .LinesPage
        tmpval = MillimetersToPoints(tmpval)
    End With
    If tmpval < 17 Then
        tmpval = Fix(tmpval * 10) / 10
    Else
        tmpval = Fix(tmpval)
    End If
    GetPageLineHeight = tmpval
End Function

Private Function GetLineHeight(ByVal size As Double) As String
    Dim tmpval As Double
    If ActiveDocument.PageSetup.LayoutMode <> wdLayoutModeDefault Then
        Dim plh As Double
        plh = GetPageLineHeight
        
        tmpval = plh
        
        Do While tmpval <= size
            tmpval = tmpval + plh
        Loop
    Else
        tmpval = size
    End If
    GetLineHeight = CStr(tmpval)
End Function
