Attribute VB_Name = "kWTHConvertHTML"
Option Explicit

Public Sub ConvertHTMLExec(ByVal htmlpath As String, ByVal cssname As String)
    Dim body As New kWTHBlockElement
    body.SetElementType betBODY
    
    Dim i As Integer
    'For EachŃANZX񂾂ǁAv΂Ȃ̂łȊ
    For i = 1 To ActiveDocument.Paragraphs.Count
        Dim para As Paragraph
        Set para = ActiveDocument.Paragraphs.Item(i)
        
        If para.Range.ListFormat.ListType <> 0 Then
            body.AddElement CreateList(i, para.Range.ListFormat.ListLevelNumber)    'ʂԂƓiXVႢ܂
        Else
            body.AddElement CreateElement(para)
        End If
        
        Set para = Nothing
    Next i
    
    'MsgBox body.CreateTag
    
    Dim tmpstr As String
    tmpstr = "<!DOCTYPE HTML PUBLIC ""-//W3C//DTD HTML 4.01//EN"">" & vbCrLf & _
             "<html lang=""ja"">" & vbCrLf & _
             "<head>" & vbCrLf & _
             "<meta http-equiv=""Content-Type"" content=""text/html; charset=Shift_JIS"">" & vbCrLf
    If cssname <> "" Then
        tmpstr = tmpstr & "<link rel=""stylesheet"" type=""text/css"" title=""" & cssname & """ href=""" & cssname & """>" & vbCrLf
    End If
    tmpstr = tmpstr & "<title>" & ActiveDocument.Name & "</title>" & vbCrLf & _
             "</head>" & vbCrLf

    Dim filenum As String
    filenum = FreeFile
    Open htmlpath For Output As filenum
    Print #filenum, tmpstr & body.CreateTag & "</html>"
    Close filenum
    
End Sub

Private Function CreateList(ByRef cnt As Integer, ByVal level As Integer) As kWTHBlockElement
    Dim ul As New BlockElement
    ul.SetElementType betUL
    
    Dim is_first As Boolean
    is_first = True
    
    Dim li As BlockElement
    Dim i As Integer
    For i = cnt To ActiveDocument.Paragraphs.Count
        Dim para As Paragraph
        Set para = ActiveDocument.Paragraphs.Item(i)
        
        If IsEndList(para, is_first, level) Then
            Exit For
        End If
        is_first = False
        
        If level < para.Range.ListFormat.ListLevelNumber Then
            li.AddElement CreateList(i, para.Range.ListFormat.ListLevelNumber)
        Else
            If Not (li Is Nothing) Then
                ul.AddElement li
                Set li = Nothing
            End If
            Set li = New BlockElement
            li.SetElementType betLI
            li.SetContent GetInlineElement(para)
        End If
        
        Set para = Nothing
    Next i
    If Not (li Is Nothing) Then
        ul.AddElement li
    End If
    Set li = Nothing
    
    cnt = i - 1
    Set CreateList = ul
End Function

Private Function IsEndList(ByVal para As Paragraph, ByVal is_first As Boolean, ByVal level As Integer) As Boolean
    Dim isend As Boolean
    isend = False
    
    If para.Range.ListFormat.ListType = 0 Then
        isend = True
    End If
    
    If level > para.Range.ListFormat.ListLevelNumber Then
        isend = True
    End If
    
    If Not is_first And para.Range.ListFormat.ListValue = 1 And para.Range.ListFormat.ListLevelNumber = 1 Then
        isend = True
    End If
    
    IsEndList = isend
End Function

Private Function CreateElement(ByVal para As Paragraph) As kWTHBlockElement
    Dim b As New kWTHBlockElement
    b.SetElementType BlockElementTypeConvert(para.Style)
    If BlockElementTypeConvert(para.Style) = betBLOCKQUOTE Then     'ȂƂC̈낤
        Dim c As New kWTHBlockElement
        c.SetElementType betP
        c.SetContent GetInlineElement(para)
        b.AddElement c
    Else
        b.SetContent GetInlineElement(para)
    End If
    Set CreateElement = b
End Function

Private Function GetInlineElement(ByVal para As Paragraph) As kWTHInlineElement
    Dim i As New kWTHInlineElement
    i.SetElementType ietNORMALTEXT
    
    Dim c As Range
    Dim btype As kwth_inline_element_type
    Dim ntype As kwth_inline_element_type
    Dim content As String
    Dim is_first As Boolean
    is_first = True
    
    'X^C1Âݒ肳Ă邽߁AÕ̕X^CێAuCN炻܂ł̗vf쐬
    For Each c In para.Range.Characters
        ntype = InlineElementTypeConvert(c.Style)
        If btype <> ntype And Not is_first Then
            i.AddElement CreateInlineElement(btype, content)
            content = ""
        End If
        is_first = False
        content = content & c.Text
        btype = ntype
    Next
    If Not is_first Then
        'Ō̉s폜
        If Right(content, 1) = vbCr Then
            content = Left(content, Len(content) - 1)
        End If
        
        i.AddElement CreateInlineElement(btype, content)
    End If
    
    Set GetInlineElement = i
End Function

Private Function CreateInlineElement(ByVal t As kwth_inline_element_type, ByVal content As String) As kWTHInlineElement
    Dim s As New kWTHInlineElement
    s.SetElementType t
    s.SetContent content
    Set CreateInlineElement = s
End Function

Private Function BlockElementTypeConvert(ByVal paragraphstyle As String) As kwth_block_element_type
    Dim e As kwth_block_element_type
    Select Case paragraphstyle
        Case ActiveDocument.Styles(wdStyleHeading1):       e = betH1
        Case ActiveDocument.Styles(wdStyleHeading2):       e = betH2
        Case ActiveDocument.Styles(wdStyleHeading3):       e = betH3
        Case ActiveDocument.Styles(wdStyleHeading4):       e = betH4
        Case ActiveDocument.Styles(wdStyleHeading5):       e = betH5
        Case ActiveDocument.Styles(wdStyleHeading6):       e = betH6
        Case ActiveDocument.Styles(wdStyleHeading7):       e = betH6
        Case ActiveDocument.Styles(wdStyleHeading8):       e = betH6
        Case ActiveDocument.Styles(wdStyleHeading9):       e = betH6
        Case ActiveDocument.Styles(wdStyleBlockQuotation): e = betBLOCKQUOTE
        Case ActiveDocument.Styles(wdStyleHtmlNormal):     e = betP
        Case ActiveDocument.Styles(wdStyleNormal):         e = betP
        Case ActiveDocument.Styles(wdStyleHtmlAddress):    e = betADDRESS
        Case ActiveDocument.Styles(wdStyleHtmlPre):        e = betPRE
    End Select
    BlockElementTypeConvert = e
End Function

Private Function InlineElementTypeConvert(ByVal paragraphstyle As String) As kwth_inline_element_type
    Dim e As kwth_inline_element_type
    Select Case paragraphstyle
        Case ActiveDocument.Styles(wdStyleEmphasis):    e = ietEM
        Case ActiveDocument.Styles(wdStyleStrong):      e = ietSTRONG
        Case ActiveDocument.Styles(wdStyleHtmlAcronym): e = ietABBR
        Case ActiveDocument.Styles(wdStyleHtmlCite):    e = ietCITE
        Case ActiveDocument.Styles(wdStyleHtmlCode):    e = ietCODE
        Case ActiveDocument.Styles(wdStyleHtmlDfn):     e = ietDFN
        Case ActiveDocument.Styles(wdStyleHtmlKbd):     e = ietKBD
        Case ActiveDocument.Styles(wdStyleHtmlSamp):    e = ietSAMP
        Case ActiveDocument.Styles(wdStyleHtmlVar):     e = ietVAR
        '''Case ActiveDocument.Styles(wdStyleHyperlink):   e = ietA
        Case Else:                                      e = ietNORMALTEXT
    End Select
    InlineElementTypeConvert = e
End Function
